package Package1;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Intervals {

    public static void main(String[] args) {

        // apre lo standard input
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        char pitchLetter = '?';
        int intervalHalftones = 0;

        // lettura del nome della nota base
        try {
            while (pitchLetter != 'A' && pitchLetter != 'B' && pitchLetter != 'C' && pitchLetter != 'D' && pitchLetter != 'E' && pitchLetter != 'F' && pitchLetter != 'G') {
                System.out.print("Inserisci il nome della nota [A..G]: ");
                pitchLetter = br.readLine().toUpperCase().charAt(0);
            }
        } catch (IOException ioe) {
            System.out.println("IO error");
            System.exit(1);
        }

        // lettura della dimensione in semitoni dell'intervallo
        try {
            System.out.print("Intervallo in numero di semitoni: ");
            intervalHalftones = Integer.parseInt(br.readLine());
        } catch (IOException ioe) {
            System.out.println("IO error");
            System.exit(1);
        } catch (NumberFormatException nfe) {
            System.out.println("Valore immesso di tipo non corretto: sono ammessi solo interi");
            System.exit(1);
        }

        int[] naturalNotesPcs = {0, 2, 4, 5, 7, 9, 11};

        // strutture dati
        String[][] notes = {
            {"C", "C#", "Cx", "Cx#", "Cxx", "Cxx#", "Cxxx", "Cbbbbb", "Cbbbb", "Cbbb", "Cbb", "Cb"},
            {"Dbb", "Db", "D", "D#", "Dx", "Dx#", "Dxx", "Dxx#", "Dxxx", "Dbbbbb", "Dbbbb", "Dbbb"},
            {"Ebbbb", "Ebbb", "Ebb", "Eb", "E", "E#", "Ex", "Ex#", "Exx", "Exx#", "Exxx", "Ebbbbb"},
            {"Fbbbbb", "Fbbbb", "Fbbb", "Fbb", "Fb", "F", "F#", "Fx", "Fx#", "Fxx", "Fxx#", "Fxxx"},
            {"Gxx#", "Gxxx", "Gbbbbb", "Gbbbb", "Gbbb", "Gbb", "Gb", "G", "G#", "Gx", "Gx#", "Gxx"},
            {"Ax#", "Axx", "Axx#", "Axxx", "Abbbbb", "Abbbb", "Abbb", "Abb", "Ab", "A", "A#", "Ax"},
            {"B#", "Bx", "Bx#", "Bxx", "Bxx#", "Bxxx", "Bbbbbb", "Bbbbb", "Bbbb", "Bbb", "Bb", "B"}
        };

        String[][] intervals = {
            {"P1", "A1", "2A1", "3A1", "4A1", "5A1", "6A1", "5d1", "4d1", "3d1", "2d1", "d1"},
            {"d2", "m2", "M2", "A2", "2A2", "3A2", "4A2", "5A2", "5d2", "4d2", "3d2", "2d2"},
            {"3d3", "2d3", "d3", "m3", "M3", "A3", "2A3", "3A3", "4A3", "5A3", "5d3", "4d3"},
            {"5d4", "4d4", "3d4", "2d4", "d4", "P4", "A4", "2A4", "3A4", "4A4", "5A4", "6A4"},
            {"5A5", "6A5", "5d5", "4d5", "3d5", "2d5", "d5", "P5", "A5", "2A5", "3A5", "4A5"},
            {"3A6", "4A6", "5A6", "5d6", "4d6", "3d6", "2d6", "d6", "m6", "M6", "A6", "2A6"},
            {"A7", "2A7", "3A7", "4A7", "5A7", "5d7", "4d7", "3d7", "2d7", "d7", "m7", "M7"}
        };

        // calcolo della rappresentazione binomiale della prima nota
        int nc_start = pitchLetter - 'C';
        if (nc_start < 0)
            nc_start += 7;
        int pc_start = naturalNotesPcs[nc_start];

        // calcolo dell'intervallo tra 0 e 11
        int pc_interval = intervalHalftones % 12;
        while (pc_interval < 0)
            pc_interval += 12;

        System.out.println("Risultati trovati");
        boolean found = false;
        for (int nc = 0; nc < 7; nc++) {
            int nc_distance = (nc - nc_start) % 7;
            if (nc_distance < 0)
                nc_distance += 7;
            // si limita a M,m,P,d,A (lunghezza stringa < 3) e a 2d, 2A
            if (intervals[nc_distance][pc_interval].length() < 3 || intervals[nc_distance][pc_interval].startsWith("2")) {
                System.out.print(pitchLetter + " >> " + notes[nc][(pc_start + pc_interval) % 12] + "    ");
                System.out.println("nc = " + nc + "; intervallo = " + intervals[nc_distance][pc_interval]);
                found = true;
            }
        }
        if (!found)
            System.out.println("Nessun intervallo trovato.");
    }
}













