package Package1;


public class RDC1 {

    public static void main(String[] args) {

        if (args.length < 2) {
            System.out.println("E' necessario immettere almeno due argomenti");
            System.exit(1);
        }

        int bpm = -1;
        int[] rdcArray = new int[args.length - 1];
        try {
            bpm = Math.abs(Integer.parseInt(args[0]));
            for (int i = 1; i < args.length; i++)
                rdcArray[i - 1] = Integer.parseInt(args[i]);
        } catch (NumberFormatException e) {
            System.out.println("Tutti gli argomenti devono essere di tipo intero");
            System.exit(1);
        }

        for (int currentNote : rdcArray) {
            String type = (currentNote > 0) ? "Nota " : "Pausa ";
            switch (Math.abs(currentNote)) {
                case 1:
                    System.out.print(type + "da un intero, ");
                    System.out.print(((double) 60 / bpm) * 4); // durata in secondi della pulsazione * 4
                    System.out.println("s");
                    break;
                case 2:
                    System.out.print(type + "da una meta', ");
                    System.out.print(((double) 60 / bpm) * 2);
                    System.out.println("s");
                    break;
                case 4:
                    System.out.print(type + "da un quarto, ");
                    System.out.print(((double) 60 / bpm));
                    System.out.println("s");
                    break;
                case 8:
                    System.out.print(type + "da un ottavo, ");
                    System.out.print(((double) 60 / bpm) / 2);
                    System.out.println("s");
                    break;
                case 16:
                    System.out.print(type + "da un sedicesimo, ");
                    System.out.print(((double) 60 / bpm) / 4);
                    System.out.println("s");
                    break;
                case 32:
                    System.out.print(type + "da un trentaduesimo, ");
                    System.out.print(((double) 60 / bpm) / 8);
                    System.out.println("s");
                    break;
                case 64:
                    System.out.print(type + "da un sessantaquattresimo, ");
                    System.out.print(((double) 60 / bpm) / 16);
                    System.out.println("s");
                    break;
                case 128:
                    System.out.print(type + "da una centoventottesimo, ");
                    System.out.print(((double) 60 / bpm) / 32);
                    System.out.println("s");
                    break;
                default:
                    System.out.println("Valore non valido");
                    break;
            }
        }
    }
}
