package Package1;


public class RDC2 {

    public static void main(String[] args) {

        if (args.length < 2) {
            System.out.println("E' necessario immettere almeno due argomenti");
            System.exit(1);
        }

        int bpm = -1;
        int[] rdcArray = new int[args.length - 1];
        try {
            bpm = Math.abs(Integer.parseInt(args[0]));
            for (int i = 1; i < args.length; i++)
                rdcArray[i - 1] = Integer.parseInt(args[i]);
        } catch (NumberFormatException e) {
            System.out.println("Tutti gli argomenti devono essere di tipo intero");
            System.exit(1);
        }
        
        String[] texts = {"un intero", "una meta'", "un quarto", "un ottavo", "un sedicesimo",
            "un trentaduesimo", "un sessantaquattresimo", "un centoventottesimo"};

        for (int currentNote : rdcArray) {
            int abs = Math.abs(currentNote);
            if (abs != 1 && abs != 2 && abs != 4 && abs != 8 && abs != 16 && abs != 32 && abs != 64 && abs != 128)
                System.out.println("Valore non valido");
            else {
                String type = (currentNote > 0) ? "Nota " : "Pausa ";
                int index = (int)(Math.log(abs) / Math.log(2));
                System.out.print(type + "da " + texts[index] + ", ");
                System.out.print(((double) 60 / bpm) * 4 / abs);
                System.out.println("s");
            }
        }
    }
}
